# Copyright (c) 2009 gocept gmbh & co. kg
# See also LICENSE.txt

import gocept.directory.interfaces
from zope.app.zopeappgenerations import getRootFolder
import zope.app.component.hooks
import zope.app.generations.utility


def is_node_or_resourcegroup(obj):
    return (gocept.directory.interfaces.INode.providedBy(obj) or
            gocept.directory.interfaces.IResourceGroup.providedBy(obj))

def evolve(context):
    """Ensure that all Node and ResourceGroup objects are registered."""
    root = getRootFolder(context)
    d = root['directory']
    site_manager = d.getSiteManager()
    zope.app.component.hooks.setSite(d)
    for obj in zope.app.generations.utility.findObjectsMatching(
            d, is_node_or_resourcegroup):
        obj.register_utility(site_manager)
    zope.app.component.hooks.setSite(None)
